%% Uncertainty visualization

function [] = U_visualization(uncertainty)

[dimRow,dimCol,dimPage]=size(uncertainty.U);
X=(1:dimCol)'; Y=(1:dimRow)';

for q=1:dimPage
    figure('Name',['Uncertainty band - Visualization - ',num2str(q)],'NumberTitle','off');
    s1=surf(X,Y,uncertainty.q,'FaceColor','g','FaceAlpha',0.5,'EdgeColor','none');
    hold on, s2=surf(X,Y,uncertainty.q-uncertainty.U(:,:,q),'FaceColor','b','FaceAlpha',0.5,'EdgeColor','none');
    hold on, s3=surf(X,Y,uncertainty.q+uncertainty.U(:,:,q),'FaceColor','r','FaceAlpha',0.5,'EdgeColor','none');
    title('Uncertainty band - Visualization','FontSize',14,'FontName','Times New Roman')
    xlabel('Pixels in x-direction','FontSize',12,'FontName','Times New Roman');
    ylabel('Pixels in y-direction','FontSize',12,'FontName','Times New Roman');
    zlabel('z-direction [µm]','FontSize',12,'FontName','Times New Roman');
    legend([s3 s1 s2],'q+U','q','q-U','Location','northeast');
end
