%% Determination of correlation distance
% I: covariance matrix arranged as (p,q,v)
% the measured surface is p*q, v=max{p,q}
% the covariance is uppertriangular
% rearrange the covanriance of each pixel in a single array
% the correlation distance is funtion of a threshold s
% i counts the interested pixel and ranges from 1 to p*q

function [corr_dist,corr_pxl]=correlation_distance(covUT,s,i)
    [p,q,~]=size(covUT);
    var_pxl=zeros(q,p);    
    
    r=floor(i/(p));c=i-r*p;
    if c==0
       r=r-1; c=p; 
    end
    jjj=1:1:p;delta=p-(jjj-1);delta0=[1 delta];k=r+1;
    start_diag=cumsum(delta0);start_diag=start_diag(1:end-1);
     clear jjj delta delta0
    corr_pxl=zeros(p,q);
    % main symmetric diagonal
    if r>0
        corr_pxl_vert=zeros(r,q);
    end
    
    corr_pxl(r+1,1:c)=(covUT(1:c,c,start_diag(1)+r))';
    corr_pxl(r+1,1+c:end)=covUT(c,1+c:end,start_diag(1)+r);

    % variance diagonal
    parfor jj=1:p
        var_pxl(:,jj)=diag(covUT(:,:,jj));
    end
    var_pxl=var_pxl';
    deltaneg=0:-1:-p+1;
    % other diagonals
%     negj=-1.*(1:1:p)+k;
    if r==floor(p/2) && rem(p,2)~=0 
        parfor j=2:p-r
            

%             if j<=r+1 % diagonals with double entrances

                corr_pxl_vert(j-1,:)=(covUT(:,c,start_diag(j)+r+deltaneg(j)))';%% vertical
                corr_pxl(j+r,:)=covUT(c,:,start_diag(j)+r);%% horizontal
%             else % diagonals with single entrances  (r+j-1)*q+1
%                 corr_pxl(j+r,:)=covUT(c,:,start_diag(j)+r);%% horizontal
% 
%             end

        end
    else 
        if r<floor(p/2) || (r==floor(p/2) && rem(p,2)==0) % extra block with horizontal reading
            parfor j=2:p-r
                

                if j<=r+1 % diagonals with double entrances reading

                    corr_pxl_vert(j-1,:)=(covUT(:,c,start_diag(j)+r+deltaneg(j)))';%% vertical
                    corr_pxl(j+r,:)=covUT(c,:,start_diag(j)+r);%% horizontal
                else % diagonals with single entrances  (r+j-1)*q+1
                    corr_pxl(j+r,:)=covUT(c,:,start_diag(j)+r);%% horizontal
                end

            end
        elseif r>floor(p/2) % extra block with vertical reading
            parfor j=2:r+1 %%
                

                if j<=p-r % diagonals with double entrances reading

                    corr_pxl_vert(j-1,:)=(covUT(:,c,start_diag(j)+r+deltaneg(j)))';%% vertical
                    corr_pxl(j+r,:)=covUT(c,:,start_diag(j)+r);%% horizontal
                else % diagonals with single entrances  (r+j-1)*q+1
                    corr_pxl_vert(j-1,:)=(covUT(:,c,start_diag(j)+r+deltaneg(j)))';%% vertical

                end

            end
        end
    end
    % Compacting
    if r>0
        corr_pxl_vert=flip(corr_pxl_vert,1);
        corr_pxl(1:r,:)=corr_pxl_vert; %reshape(corr_pxl_vert',1,[]);
        clear corr_pxl_vert
    end

%     var_pxl=reshape(var_pxl',1,[]);
    % Calculating
    maxcov=(sqrt(var_pxl).*sqrt(var_pxl(r+1,c))); %%%%%%
    Pearson_pxl=abs(round(corr_pxl,8)./round(maxcov,8));
%     Pearson_pxl_sq=Pearson_pxl.^2;
    logic=Pearson_pxl<s;%logic_sq=Pearson_pxl_sq<0.5;
    if i==1||i==1000*1000||i==1000*500||i==500*500||i==250*250
        f=figure;surf(Pearson_pxl);
        savefig(f,strcat('Pearson_pxl',num2str(i)));
        close(f);
    end
    corr_distxn=find(logic(r+1,1:c),1);corr_distxp=find(logic(r+1,c+1:end),1)+c;
    corr_distyn=find(logic(1:r+1,c),1);corr_distyp=find(logic(r+1+1:end,c),1);
    corr_dist=max([corr_distxn,corr_distxp,corr_distyn,corr_distyp]);
    if isempty(corr_dist)
        corr_dist=p*q-min([r+1,c]);
    end

end
