%% Calculation of a upper triangular block covariance matrix

function covfUBM=covaMatUT_cluster(dsfR,nfSplit)

    [~,dimfCol]=size(dsfR);
    nfSel=dimfCol/nfSplit;                     % number of elements in a block matrix
    nfBdia=dimfCol/nfSel;                      % number block matrices on the diagonal
    nfBlock=0.5*nfSplit*(nfSplit+1);           % number of block matrix
    covfUBM=nan(nfSel,nfSel,nfBlock);          % block matrices arranged in pages (upper triangular side)

    %nfp=0;                                     % track of the number of pages in cBM
    %cfi=0;                                     % selection of block matrices on lines parallel to the block diagonal
    % treat separately the diagonal line of blocks
%     parfor v=1:nfBdia
%                 for p=1:nfSel
%                     for q=p:nfSel              % build the blocks on the diagonal
%                         tmpfC=cov(dsfR(:,p+(v-1)*nfSel),dsfR(:,q+(v-1)*nfSel));
%                         covfUBM(p,q,v)=tmpfC(1,2);
%                     end
%                 end
%     end
    %nfp=nfBdia;  % matrix pages update
    clear v p q
    jjj=1:1:nfSplit;delta=nfSplit-(jjj-1);delta0=[0 delta];
    end_diag=cumsum(delta0);end_diag=end_diag(2:end);
    kk=[0 0:1:nfSplit-2];
    TCOV=mat2cell(covfUBM,nfSel,nfSel,[nfSplit diff(end_diag)]);
%     A=zero(nfSel,nfSel,nfBdia-2+1);
    parfor u=1:nfSplit                            % lines of blocks
        A=TCOV{u};
        if u==1
            for v=1:nfBdia
                for p=1:nfSel
                    for q=p:nfSel              % build the blocks on the diagonal
                        tmpfC=cov(dsfR(:,p+(v-1)*nfSel),dsfR(:,q+(v-1)*nfSel));
                        A(p,q,v)=tmpfC(1,2);
                    end
                end
                TCOV{u}=A;
            end
        else
            for v=1:nfBdia-u+1

                for p=1:nfSel
                    for q=1:nfSel              % build the upper blocks
                        tempC=cov(readMatrix1(dsfR,p,v,nfSel),readMatrix2(dsfR,q,v,nfSel,kk(u)));
                        A(p,q,v)=tempC(1,2);

                    end
                end
                TCOV{u}=A;
            end
        end
    end
    covfUBM=cell2mat(TCOV);

end

function [outputM]=readMatrix1(inputM,p,v,nfSel)
outputM=inputM(:,p+(v-1)*nfSel);
end

function [outputM]=readMatrix2(inputM,q,v,nfSel,cfi)
outputM=inputM(:,q+(v+cfi)*nfSel);
end

% function [outputM]=readMatrixDiag(inputM,)