function [covUBM]=covaMat_sampling_fcn(ZIn)

%% Import dataset
% the indeces are adjusted for surface data organized in each page
[dimR,dimC,dimP] = size(ZIn);
dsR=ones(dimP,dimR*dimC);

% the reshape of the matrix is done for each page separately, which becomes
% a single row in the matrix dsR (data set reshaped)
parfor q=1:dimP
dsR(q,:)=reshape(ZIn(:,:,q)',[1,dimR*dimC]);
end
clear q

% w=zeros(1,500); w(1)=251;
% t=zeros(1,500); t(1)=750;
% for q=2:500
%     w(q)=w(q-1)+1000;
%     t(q)=t(q-1)+1000;
%     w(q):t(q)
% end
%w=[3251:3750,7251:7750,8251:8750];
%w=[251:750,1251:1750,2251:2750,3251:3750,4251:4750,5251:5750,6251:6750,7251:7750,8251:8750,9251:9750];
%w=[251:750,1251:1750,2251:2750];
%w=[1:5000,250000:255000,500000:505000,750000:755000,995000:1000000];
%w=497001:503000;
%w=999500:1000000;
w=1:dimR*dimC; % w=1:putni tot matrice
shortMatR=dsR(:,w);
% [dimRow,dimCol] = size(shortMatR);

% covBM=cov(shortMatR);                   % full covariance matrix

% [mutualcorr,delays]=xcorr(shortMatR);   % cross-correlation
% [Mcorr,indxM]=max(mutualcorr);
% [mcorr,indxm]=min(mutualcorr);
% [MMcorr,idxM]=max(Mcorr);
% [mmcorr,idxm]=min(mcorr);
% delayM=indxM(idxM);                     % index delay of maximum
% delaym=indxm(idxm);                     % index delay of maximum

%% Initiate block matrices
% fprintf('Type the number of diagonal blocks (submultiple of the \nnumber of column in the covariance matrix %d): ',dimRow*dimCol);
% nSplit=input('   ');
nSplit = max([dimR,dimC]); %pari al numero di elementi sulla diagonale

% Calculation of a upper triangular block covariance matrix
% tic
covUBM=covaMatUT_cluster(shortMatR,nSplit); % versione cluster
% toc
% covUBM_serial=covaMatUT(shortMatR,nSplit);
% logic_check=covUBM==covUBM_serial;
% aP=covUBM(:,:,1);aS=covUBM_serial(:,:,1);aL=logic_check(:,:,1);

% save('covUBM_SS_reduced_50x50.mat','covUBM','-v7.3');

% % Calculation of a lower triangular block covariance matrix
% covLBM=covaMatLT(shortMatR,nSplit);
% save(covLBM,'covLBM','-v7.3');
% 
% 
%% check the simmetry of the covariance matrix
% [~,nSel,nBlock]=size(covUBM);
% simmTest=zeros(size(covUBM));
% for q=1:nBlock
%     simmTest(:,:,q)=covUBM(:,:,q)-covLBM(:,:,q)';
% end

% % Cross correlation representation
% % upper triangular block covariance matrix
% iLimCorr=min(mutualcorr,[],'all');
% ILimCorr=max(mutualcorr,[],'all');

% figure
% imC=imagesc(mutualcorr,[iLimCorr ILimCorr]);
% colormap(gray)
% %colormap(bone)
% corrMB=imC.CData;
% %imC.CDataMapping='direct';
% imC.CDataMapping='scaled';
% savefig('Cross correlation representation');

% %% Full covariance representation
% % upper triangular block covariance matrix
% iLimMB=min(covBM,[],'all');
% ILimMB=max(covBM,[],'all');
% 
% figure
% imC=imagesc(covBM,[iLimMB ILimMB]);
% colormap(gray)
% %colormap(bone)
% covMB=imC.CData;
% %imC.CDataMapping='direct';
% imC.CDataMapping='scaled';
% savefig('Full covariance representation');


%% Image-like representation
% upper triangular block covariance matrix
iLimUMB=min(covUBM,[],'all');
% iLimUMB=-1;
ILimUMB=max(covUBM,[],'all');
% ILimUMB=1;
for q=1:nBlock
    f=figure(q+2);
    imC=imagesc(covUBM(:,:,q),[iLimUMB ILimUMB]);
    colormap(gray)
    %colormap(bone)
    UMB=imC.CData;
    %imC.CDataMapping='direct';
    imC.CDataMapping='scaled';
    savefig(f,strcat('Image-like_representation_upper triangular block covariance matrix',num2str(q)));
    close(f);
end
clear q

% % lower triangular block covariance matrix
% iLimLMB=min(covLBM,[],'all');
% ILimLMB=max(covLBM,[],'all');
% for q=1:nBlock
%     figure(q+nBlock+2)
%     imC=imagesc(covLBM(:,:,q),[iLimLMB ILimLMB]);
%     colormap(gray)
%     %colormap(bone)
%     UMB=imC.CData;
%     %imC.CDataMapping='direct';
%     imC.CDataMapping='scaled';
%     savefig(['Image-like representation_lower triangular block covariance matrix',num2str(q)]);
% end
% clear q

% %% Surface-like representation
% figure                          % cross-correlation
% surf(mutualcorr);
% savefig('Surface-like representation_cross-correlation');
% 
% x=0:nSel-1;
% y=0:nSel-1;
% [X,Y]=meshgrid(x,y);
% 
% % figure                          % full covariance matrix
% % surf(X,Y,covBM);
% % savefig('Surface-like representation_full covariance matrix');
% % upper triangular block covariance matrix
% for q=1:nBlock
%     figure(q+2*nBlock+4)
%     surf(X,Y,covUBM(:,:,q));
%     savefig(['Surface-like representation_upper triangular block covariance matrix',num2str(q)]);
% end
% clear q

% % lower triangular block covariance matrix
% for q=1:nBlock
%     figure(q+3*nBlock+4)
%     surf(X,Y,covLBM(:,:,q));
%     savefig(['Surface-like representation_lower triangular block covariance matrix',num2str(q)]);
% end
% clear q
end

% clear A B C dimRow dimCol dimPage dsR iLimUMB ILimUMB iLimLMB ILimLMB
% clear imC xA XA xB XB xC XC  xPA xPB xPC yA YA yB YB yC YC yPA yPB yPC tempC