function [XIn,YIn,ZIn,Zv,parameters,Ix,Iy] = datx_import(pathfile)

scala1 = 1e-3; % From nm to m
scala2 = 1e+9; % From m to nm

Ix = (h5readatt(pathfile,'/Measurement/Attributes',...
    'Surface Data Context.Lateral Resolution:Value'))*scala2;
Iy = Ix;
parameters = zeros(7,1);
% parameters(2) = x_pixels
% parameters(3) = y_pixels
% parameters(4) = x_length 
% parameters(5) = y_length 
parameters(2) = h5readatt(pathfile,'/Measurement/Attributes',...
    'Data Context.Data Attributes.Camera Width:Value');
parameters(3) = h5readatt(pathfile,'/Measurement/Attributes',...
    'Data Context.Data Attributes.Camera Height:Value');
parameters(4) = Ix*parameters(2);
parameters(5) = Iy*parameters(3);

ZIn = (h5read(pathfile,'/Measurement/Surface'));

% Correct the "No Data" values to NaN: typically a large number, 1.7977e+308
zv = h5readatt(pathfile,'/Measurement/Surface','No Data');                 
Zv = ZIn == zv;
ZIn(Zv) = NaN;
ZIn = ZIn*scala1;

% Definition of the grid in x-direction and y-direction.
x = [0:Ix:parameters(4)-1]*scala1;                                         
y = [0:Iy:parameters(5)-1]*scala1;
% XIn (In as input) is a matrix where each row is a copy of x, and YIn 
% is a matrix where each column is a copy of y. The grid represented
% by the coordinates X and Y has length(y) rows and length(x) columns.
[XIn,YIn] = meshgrid(x,y);                                                 
                                                                           