%% Outliers identification on the surface

function [] = ol_visualization(file,data,outliers)

[~,~,dimPage]=size(data.Zpc);
for q=1:dimPage
    figure('Name',file{q},'NumberTitle','off');
    surf(data.XIn,data.YIn,data.Zpc(:,:,q),'LineStyle','none','FaceColor','flat');
    colormap jet; title('Outliers identification in the surface',...
        'FontSize',14,'FontName','Times New Roman')
    hold on
    % A cross at the locations specified by the vectors Xol, Yol, and Zol
    % shows the outliers.
    s1 = scatter3(outliers.Xol{1,q},outliers.Yol{1,q},...
        outliers.Zol{1,q},'x','MarkerEdgeColor','red');                    
    legend(s1,'Outlier','location','northeast');
    c = colorbar; c.Label.String = '[m]';
    xlabel('x-direction [m]','FontSize',12,'FontName','Times New Roman');
    ylabel('y-direction [m]','FontSize',12,'FontName','Times New Roman');
    zlabel('z-direction [m]','FontSize',12,'FontName','Times New Roman');
end