%% Plane correction dialog box

function [indx,tf] = pc_dialogbox()

% This cell array contains the names of the various methods for the plane correction.
list = {'Surface leveling','Surface curvature removal'};

% It creates a dialog box that allows the user to select one
% (the 'SelectionMode' is set on 'single') item from the specified list.
% The function returns two output arguments:
% indx, which contains information about which items the user selected,
% and tf, which indicates whether the user made a selection.
[indx,tf] = listdlg('ListString',list,'SelectionMode','single',...          
    'ListSize',[350,150],'Name','Plane correction','OKString','Apply',...  
    'PromptString',{'Select a file.',...                                    
    'Only one file can be selected at a time.',''});                       
                                                                          
fprintf('User selected: %s.\n',list{indx});