%% Significance Test

function [hr] = significance_test(residuals,RobustnessPar,t,reply)

if ~isempty(reply) && (reply=='N'||reply=='n')
    disp('The Normality Test for the Residuals operation was canceled by the user.');
    hr = [];
else
    hr = chi_squared_test(residuals,t);         
end

[dimRow,dimCol,~]=size(residuals);
    
s0 = sum(RobustnessPar(:,:,1),'all')/(dimRow*dimCol)*100;
format shortg
s0 = round(s0,3,'significant');
s1 = sum(RobustnessPar(:,:,2),'all')/(dimRow*dimCol)*100;
format shortg
s1 = round(s1,3,'significant');
figure('Name','Significance Test','NumberTitle','off');
title({'Coefficient p0',['Percentage of pixels where the Significance Test succeeded:',num2str(s0),'%']},...
    'FontSize',14,'FontName','Times New Roman')
surface(RobustnessPar(:,:,1),'LineStyle','none','FaceColor','flat'), colorbar
axis square, axis equal, axis xy, axis([0 dimCol 0 dimRow])
figure('Name','Significance Test','NumberTitle','off');
title({'Coefficient p1',['Percentage of pixels where the Significance Test succeeded:',num2str(s1),'%']},...
    'FontSize',14,'FontName','Times New Roman')
surface(RobustnessPar(:,:,2),'LineStyle','none','FaceColor','flat'), colorbar
axis square, axis equal, axis xy, axis([0 dimCol 0 dimRow])