%% Surface leveling

function [Zpc,ct] = surface_leveling(XIn,YIn,ZIn)

tic
[~,~,dimPage]=size(ZIn);
Zsf = zeros(size(ZIn));

parfor q=1:dimPage
    [XOut,YOut,ZOut]=prepareSurfaceData(XIn,YIn,ZIn(:,:,q));
    % Creation of a surface fit to the data in vectors XOut, Yout and ZOut, 
    % conveniently processed with 'prepareSurfaceData' function. 
    % Model type to fit is a Polynomial surface, model names are 'polyij', 
    % where i is the degree in x and j is the degree in y.
    sf=fit([XOut,YOut],ZOut,'poly11');                                     
    Zsf(:,:,q)=sf(XIn,YIn);                                      
end

% The plane correction is achieved subtracting the fit surface to the measured surface.
Zpc=ZIn-Zsf;                                                               
ct=toc;