%% Spikes and Voids detection

function [Xs,Ys,Zs,Xv,Yv,Zv] = sv_detection(Zpc,Zv,Sq,Ix,Iy)

[~,~,dimPage]=size(Zpc);
Xs=cell(1,dimPage);
Ys=cell(1,dimPage);
Zs=cell(1,dimPage);
Xv=cell(1,dimPage);
Yv=cell(1,dimPage);
parfor q = 1:dimPage
    %Spikes
    Zs{1,q}=abs(Zpc(:,:,q)) > 3*Sq(1,q);
    Zs{1,q}=Zpc(:,:,q).*Zs{1,q};
    %Find indices and values of nonzero elements.
    [Ys{1,q},Xs{1,q},Zs{1,q}] = find(Zs{1,q});                             
    Xs{1,q} = ((Xs{1,q}-1).*Ix)*1e-3;
    Ys{1,q} = ((Ys{1,q}-1).*Iy)*1e-3;
    %Voids
    [Yv{1,q},Xv{1,q}] = find(Zv(:,:,q));
    Xv{1,q} = ((Xv{1,q}-1).*Ix)*1e-3;
    Yv{1,q} = ((Yv{1,q}-1).*Iy)*1e-3;
end

Zv = cell(1,dimPage);
parfor q = 1:dimPage
    Zv{1,q} = zeros(length(Xv{1,q}),1);
end