%% Spikes and Voids identification on the surface

function [] = sv_visualization(file,data,spikes,voids)

[~,~,dimPage]=size(data.Zpc);
for q=1:dimPage
    figure('Name',file{q},'NumberTitle','off');
    surf(data.XIn,data.YIn,data.Zpc(:,:,q),'LineStyle','none','FaceColor','flat')
    title('Spikes and Voids identification on the surface','FontSize',14,'FontName','Times New Roman')
    colormap jet; c = colorbar; c.Label.String = '[µm]';
    hold on
    % Displays cross at the locations specified by the vectors Xs, Ys, and Zs to show the spikes.
    s1=scatter3(spikes.Xs{1,q},spikes.Ys{1,q},spikes.Zs{1,q},'*','MarkerEdgeColor','red');           
    hold on
    % Displays circles at the locations specified by the vectors Xv, Yv, and Zv to show the voids.
    s2=scatter3(voids.Xv{1,q},voids.Yv{1,q},voids.Zv{1,q},2,'w','filled');                         
    legend([s1 s2],'Spike','Void','Location','northeast');
    xlabel('x-direction [µm]','FontSize',12,'FontName','Times New Roman');
    ylabel('y-direction [µm]','FontSize',12,'FontName','Times New Roman');
    zlabel('z-direction [µm]','FontSize',12,'FontName','Times New Roman');
end