function [XIn,YIn,ZIn,Zv,parameters,Ix,Iy] = txt_import(pathfile)

formatSpec='%f%f%f';
fileID = fopen(pathfile,'r');
if fileID == -1,disp('Error, check file name and path');
else
    % Reading of file data using the format of the data fields 
    % ('formatSpec') for the number of 'lines'.
    % In this specific case the delimiter is a white-space.
    dataArray=textscan(fileID, formatSpec, ...                             
        'Delimiter', ' ', 'EmptyValue' ,NaN, 'ReturnOnError', false);      
    fclose(fileID);
end

parameters = zeros(7,1);
scala = 1e-3;
% parameters(2) = x_pixels
% parameters(3) = y_pixels
% parameters(4) = x_length 
% parameters(5) = y_length 
parameters(2)=sum(dataArray{1,2} == dataArray{1,2}(1,1));
parameters(3)=sum(dataArray{1,1} == dataArray{1,1}(1,1));
Ix=dataArray{1,1}(2,1)-dataArray{1,1}(1,1); % Pixel's size expressed in nm.
Iy=dataArray{1,2}(1+parameters(2),1)-dataArray{1,2}(1,1);
parameters(4)=Ix * parameters(2);
parameters(5)=Iy * parameters(3);
parameters(6)=min(dataArray{1,1});
parameters(7)=min(dataArray{1,2});

% The input data are reshaped in order to have XIn (In as input) 
% as a matrix where each row contains the coordinates along 
% the x-direction, and YIn as a matrix where each column contains 
% the coordinates along the y-direction.
XIn = ((reshape(dataArray{1,1},[parameters(2),parameters(3)])).').*scala;
YIn = ((reshape(dataArray{1,2},[parameters(2),parameters(3)])).').*scala;
% Off-set removal
XIn = XIn-(parameters(6)*scala);
YIn = YIn-(parameters(7)*scala);
ZIn = ((reshape(dataArray{1,3},[parameters(2),parameters(3)])).').*scala;
Zv = isnan(ZIn);