%% Uncertainty evaluation

function [q,U] = uncertainty_evaluation(Regression)

Z=Regression.Corrected;

[~,~,dimPage]=size(Z);
time = (-(dimPage/2):(dimPage/2)-1)';
time = permute(time,[3,2,1]);
u_p0 = sqrt(Regression.se(:,:,1));
u_p1 = sqrt(Regression.se(:,:,2));

% Combined standard uncertainty
uc = sqrt(((time.*u_p1).^2+(u_p0).^2+(Regression.rmse).^2));
% Coverage factor (level of confidence ---> 95 %)
k = 2;
% Expanded uncertainty
U = k.*uc;

q = mean(Z,3);